function [F, rts, iter, res] = ClosestPolyArbSup(sys,support,tcond,init, maxiter) 

nsup = size(support,2)/2;
npoly = size(sys, 2)/2;
[npts, nvar] = size(init);
for i = 1:npts
    ntc(i) = size(tcond{i}, 2)/2;
end
totalcond = sum(ntc);

rts = init;
iter = 0;
minstep = 10^(-8);
stepsize = minstep+1;
I = eye(nvar);
maxsk = 15;
sk = 0;
                
while (iter < maxiter && sk < maxsk)
    [fev, df] = buildfev(rts, sys, tcond);

    V = VandMat(rts, nsup, ntc, support, tcond);
    dV = {};
    for i = 1:nvar
        dsup = support;
        for j = 1:nsup
            [dsup{2*j-1}, dsup{2*j}] = mpolydiff(support{2*j-1}, support{2*j}, [1], I(i,:));
        end
        dV{i} = VandMat(rts, nsup, ntc, dsup, tcond);
    end
    g = (V*V')\fev;
    F = V'*g;
    
    allF = F(:);
    allfev = fev(:);
    
    J = zeros(npoly*nsup, npts*nvar);
    
        col = 1;
        for j = 1:npts
            for k = 1:nvar
                ddV = zeros(totalcond, nsup);
                ddV((sum(ntc(1:(j-1)))+1):(sum(ntc(1:j))),:) = dV{k}((sum(ntc(1:(j-1)))+1):(sum(ntc(1:j))),:);
                
                ddf = zeros(totalcond, npoly);
                for i=1:npoly
                    ddf((sum(ntc(1:(j-1)))+1):(sum(ntc(1:j))),i) = df{i}((sum(ntc(1:(j-1)))+1):(sum(ntc(1:j))),k);
                end
                tmp = V'*((V*V')\(ddf-ddV*F));
                J(: ,col) = tmp(:);
                col = col + 1;
            end
        end

    step = -J\allF;
    stepsize = norm(step,2);

    %line search
    currentres = norm(fev(:));
    
    
    newrts = rts;
    for i = 1:npts
        newrts(i,:) = newrts(i,:) + step(((i-1)*nvar+1):i*nvar,1).';
    end
    [newfev] = buildfev(newrts, sys, tcond);
    newres = norm(newfev(:));
    sk = 0;
    
    while newres > 0.99 * currentres && sk < maxsk+1
        step = 0.5 .* step;
        newrts = rts;
        for i = 1:npts
            newrts(i,:) = newrts(i,:) + step(((i-1)*nvar+1):i*nvar,1).';
        end
        [newfev] = buildfev(newrts, sys, tcond);
        newres = norm(newfev(:));
        sk = sk+1;
    end

    if sk == 0
        dbls = 0;
      %see if we can double the step size
      while newres < 0.99 * currentres && dbls < 10
          newrts = rts;
          for i = 1:npts
              newrts(i,:) = newrts(i,:) + 2.0 .* step(((i-1)*nvar+1):i*nvar,1).';
          end
          [newfev] = buildfev(newrts, sys, tcond);
          currentres = newres;
          newres = norm(newfev(:));
          if newres < 0.99 * currentres
              step = 2.0 .* step;
          end
          dbls = dbls + 1;
      end
      newres = currentres; %corrects for return value
    end
    for i = 1:npts
        rts(i,:) = rts(i,:) + step(((i-1)*nvar+1):i*nvar,1).';
    end
    iter = iter+1;
    
end
        
res = newres;

end