function [F, rts, iter] = ClosestPolyArbSupComp(sys,support,tcond,init, maxiter) 


nsup = size(support,2)/2;
npoly = size(sys, 2)/2;
[npts, nvar] = size(init);
for i = 1:npts
    ntc(i) = size(tcond{i}, 2)/2;
end
totalcond = sum(ntc);

rts = init;
iter = 0;
minstep = 10^(-8);
stepsize = minstep+1;
I = eye(nvar);
maxsk = 15;
sk = 0;
                
while (iter < maxiter && sk < maxsk)
    
    fev = zeros(totalcond,npoly);
    df = {};
    for i = 1:npoly
        row = 1;
        df{i} = zeros(totalcond, nvar);
        for j = 1:npts
            for k = 1:ntc(j)
                [p, s] = mpolydiff(sys{2*i-1}, sys{2*i}, tcond{j}{2*k-1}, tcond{j}{2*k});
                fev(row, i) = mpolyeval(p, s, rts(j,:));
                for t = 1:nvar
                   [p1, s1] = mpolydiff(p, s, [1], I(t,:));
                   df{i}(row,t) = mpolyeval(p1, s1, rts(j,:));
                end
                row = row + 1;
            end
        end
    end

    V = VandMat(rts, nsup, ntc, support, tcond);
    dV = {};
    for i = 1:nvar
        dsup = support;
        for j = 1:nsup
            [dsup{2*j-1}, dsup{2*j}] = mpolydiff(support{2*j-1}, support{2*j}, [1], I(i,:));
        end
        dV{i} = VandMat(rts, nsup, ntc, dsup, tcond);
    end
    g = (V*V')\fev;
    F = V'*g;
    
    allF = F(:);
    allfev = fev(:);
    
    J = zeros(npoly*nsup, npts*nvar);
    
%    for i = 1:npoly
        col = 1;
        for j = 1:npts
            for k = 1:nvar
                ddV = zeros(totalcond, nsup);
                ddV((sum(ntc(1:(j-1)))+1):(sum(ntc(1:j))),:) = dV{k}((sum(ntc(1:(j-1)))+1):(sum(ntc(1:j))),:);

                ddf = zeros(totalcond, npoly);
                for i=1:npoly
                    ddf((sum(ntc(1:(j-1)))+1):(sum(ntc(1:j))),i) = df{i}((sum(ntc(1:(j-1)))+1):(sum(ntc(1:j))),k);
                end
%                g = (V*V')\fev;
                tmp = ddV'*g+V\(ddf - ddV*F - V*ddV'*g);
                J(: ,col) = tmp(:);
%                tmp = ddV'*g(:,i)+V\(ddf - ddV*F(:,i) - V*ddV'*g(:,i));
%                J(((i-1)*nsup+1):i*nsup ,col) = tmp;
                col = col + 1;
            end
        end
 %   end

    step = -J\allF;
    stepsize = norm(step,2);
    %line search
    currentres = norm(fev(:));
    
    
    newrts = rts;
    for i = 1:npts
        newrts(i,:) = newrts(i,:) + step(((i-1)*nvar+1):i*nvar,1)';
    end
    [newfev] = buildfev(newrts, sys, tcond);
    newres = norm(newfev(:));
    sk = 0;
    
    while newres + eps > currentres && sk < maxsk+1
        step = 0.5 .* step;
        newrts = rts;
        for i = 1:npts
            newrts(i,:) = newrts(i,:) + step(((i-1)*nvar+1):i*nvar,1).';
        end
        newrts(:) = newrts(:) + step;
        [newfev] = buildfev(newrts, sys, tcond);
        newres = norm(newfev(:));
        sk = sk+1;
    end

    for i = 1:npts
        rts(i,:) = rts(i,:) + step(((i-1)*nvar+1):i*nvar,1).';
    end
    iter = iter+1;
end

        
    

end