function [fev, df] = buildfev(rts, sys, tcond)

if nargout == 1
    calcdf = 0;
else
    calcdf = 1;
end

npoly = size(sys, 2)/2;
[npts, nvar] = size(rts);
for i = 1:npts
    ntc(i) = size(tcond{i}, 2)/2;
end
totalcond = sum(ntc);

fev = zeros(totalcond,npoly);
if calcdf
    df = {};
end

I = eye(nvar);
for i = 1:npoly
    row = 1;
    
    if calcdf
        df{i} = zeros(totalcond, nvar);
    end
    
    for j = 1:npts
        for k = 1:ntc(j)
            [p, s] = mpolydiff(sys{2*i-1}, sys{2*i}, tcond{j}{2*k-1}, tcond{j}{2*k});
            fev(row, i) = mpolyeval(p, s, rts(j,:));
            
            if calcdf
                for t = 1:nvar
                   [p1, s1] = mpolydiff(p, s, [1], I(t,:));
                   df{i}(row,t) = mpolyeval(p1, s1, rts(j,:));
                end
            end
            
            row = row + 1;
        end
    end
end
