function displaymatrix (outfile, A, varargin)
%appends to outfile a table displaying the contents of A
%with column headers
%
%

%open file for append
fid = fopen(outfile, 'a');

cols = size(A, 2);
rows = size(A, 1);

%first line of LaTeX table
fprintf(fid, '\\begin{tabular}{c');

%specify centered columns
for i = 2:cols
    fprintf(fid, '|c');
end

%close off column description and begin column headings
fprintf(fid, '}\n');
if (nargin >= 3)
    fprintf(fid, '%s', varargin{1});

    for i = 2:(nargin-2)
        fprintf(fid, ' & %s', varargin{i});
    end
end

fprintf(fid, '\\\\ \\hline\n');

for j = 1:rows
    fprintf(fid, '%g', A(j, 1));
    
    for i = 2:cols
        fprintf(fid, ' & %g', A(j, i));
    end
    fprintf(fid, '\\\\\n');
end

fprintf(fid, '\\end{tabular}\n');


fclose(fid);