function [p, s] = lexorder(poly, support)
%function [p, s] = lexorder(poly, support)
%
%Support is an NxM matrix of exponents
%
%poly is a vector of N elements representing coefficients
%  of a multivariate polynomial with given support
%
%[p, s] represents the same polynomial with coefficients
%  is lexigraphical order

[s, I] = sortrows(support);
p = poly(I);