function [p, s] = mpolyadd(p1, s1, p2, s2)
%function [p,s] = mpolyadd(p1, s1, p2, s2)
%
%Adds the multivariate polynomials [p1,s1]
%  and [p2, s2]
if isvector([p1 p2])
    pnew = [p1 p2];
else
    pnew = [p1;p2];
end
[N1, M1] = size(s1);
[N2, M2] = size(s2);

if M1<M2
    ts1 = zeros(N1,M2);
    ts1(:, 1:M1) = s1;
    ts2 = s2;
elseif M2<M1
    ts2 = zeros(N2, M1);
    ts2(:, 1:M2) = s2;
    ts1 = s1;
else
    ts1 = s1;
    ts2 = s2;
end

[p, s] = mpolysimplify(pnew, [ts1;ts2]);