function [p, s] = mpolymult(p1, s1, p2, s2)
%function [p, s] = mpolymult(p1, s1, p2, s2)
%
%Multiplies 2 multivariate polynomials

[N1, M1] = size(s1);
[N2, M2] = size(s2);
M = max(M1, M2);
N = N1*N2;
p = zeros(1, N);
s = zeros(N, M);

if (M1 < M2)
   %pad the smaller matrix with zeros
   ts1 = zeros(N1, M2);
   ts1(1:N1, 1:M1) = s1;
   ts2 = s2;
elseif (M2 < M1)
    ts2 = zeros(N2, M1);
    ts2(1:N2, 1:M2) = s2;
    ts1 = s1;
else
    ts1 = s1;
    ts2 = s2;
end

for i = 1:N1
    for j = 1:N2
        p(j+N2*(i-1)) = p1(i)*p2(j);
        s(j+N2*(i-1), :) = ts1(i,:) + ts2(j,:);
    end
end
[p s] = mpolysimplify(p, s);