function [F, rts, iter, support, origsys, psys, res, berr, begres, pmag, t] = runsimpcase(rseed, d, nvar, npoly, tconds, err, dist)

rand('seed', rseed);

nroots = size(tconds, 2);
npts = nroots;
for i = 1:nroots
    ntc(i) = size(tconds{i}, 2)/2;
end

totalcond = sum(ntc);

sys = {};

for i = 1:npoly
%    [sys{2*i-1}, sys{2*i}] = mrandpoly(d, nvar*d, nvar);
    [p1,s1] = mrandpoly(d, nvar*d, nvar);
    [p2,s2] = mrandpoly(d, nvar*d, nvar);

    [sys{2*i-1}, sys{2*i}] = mpolyadd(p1, s1, 1i*p2, s2);
end

%rts = rand(nroots, nvar);
rts = rand(nroots, nvar) + 1i*rand(nroots, nvar);
I = eye(nvar);

%function V=VandMat(pts, numsupport, numcond, varargin)
numsupport = totalcond;

sup = {[1], [0]};

for i = 1:numsupport
    support(i,:) = inttovec(i, nvar);
    sup{2*i - 1} = 1;
    sup{2*i} = support(i,:);
end
%i = 2; j = zeros(1, nvar);
%support(1,:) = j;
%for i = 2:numsupport
%    sup{2*i-1} = 1;
%    [b, k] = min(j);
%    j(k) = j(k) + 1;
%    sup{2*i} = j;
%    support(i,:) = j;
%end
V = VandMat(rts, numsupport, ntc, sup, tconds);

fev = [];
for i = 1:npoly
    row = 1;
    for j = 1:npts
        for k = 1:ntc(j)
            [p, s] = mpolydiff(sys{2*i-1}, sys{2*i}, tconds{j}{2*k-1}, tconds{j}{2*k});
            fev(row, i) = mpolyeval(p, s, rts(j,:));
            row = row + 1;
        end
    end
end
origsys = sys;
F = V\fev;
pmag = 0;
for i = 1:npoly
    [sys{2*i-1}, sys{2*i}] = mpolyadd(sys{2*i-1}, sys{2*i}, -F(:,i).', support);
    origsys{2*i-1} = sys{2*i-1};
    origsys{2*i} = sys{2*i};
%    [p, s] = mrandpoly(d, nvar*d, nvar);
p = rand(1,numsupport);
    p = p*err/norm(p, 2);  %to perturb the system
    [sys{2*i-1}, sys{2*i}] = mpolyadd(sys{2*i-1}, sys{2*i}, p, support);
    pmag = pmag + norm(p, 2)^2;
end
pmag = sqrt(pmag);
psys = sys;
fbeg = buildfev(rts, psys, tconds);
begres = norm(fbeg(:), 2);

init = rts + rand(size(rts))*dist; %to move the initial iterate away from the solution
tic;
[F, rts, iter, res] = ClosestPolySimp(sys,sup,tconds, init, 150);
t = toc;
%update the system based on output of ClosestPoly
for i = 1:npoly
    [sys{2*i-1}, sys{2*i}] = mpolyadd(sys{2*i-1}, sys{2*i}, -F(:,i).', support);
end

%find 2-norm of (sys-origsys)
berr = 0;
for i = 1:npoly
    [p,s] = mpolyadd(sys{2*i-1}, sys{2*i}, -origsys{2*i-1}, origsys{2*i});
    berr = berr + norm(p,2)^2;
end
berr = sqrt(berr);
