function [avgres, avgberr, avgiter, avgadjust, avgbegres, avgpmag, avgtime, cvg] = runtest(r, deg, nvar, npoly, tconds, err, dist)
%r is the number of cases to run
%deg is the total degree of the polynomials to generate
%nvar is the number of variables
%npoly is the number of polynomials
%tconds are the tangential conditions to use
%err is the 2-norm of the perturbation to impose
%dist is the distance the initial iterate will be from the roots of the
%non-pertrubed system.
%each return value is a vector indexed by the number of times dist need to
%be halved to get a convergent result

avgres = zeros(10,1);
avgberr = zeros(10,1);
avgiter = zeros(10,1);
avgadjust = zeros(10,1);
avgbegres = zeros(10,1);
avgpmag = zeros(10,1);
avgtime = zeros(10,1);
cvg = zeros(10,1);
for i = 1:r
    cdist = dist*2.0;
    k = 0;
    F = [100];
    berr = 1;
    pmag = 0;
    pmag = 0;
    res = 1;
    begres = 0;

%  while norm(F(:)) > pmag && k < 10
%  while res > begres && k < 10
while berr > pmag && k < 10     
    cdist = cdist/2.0;
    [F, rts, iter, support, origsys, psys, res, berr, begres, pmag, t] = runtestcase(i, deg, nvar, npoly, tconds, err, cdist);
    k = k+1;
  end
  avgbegres(k) = avgbegres(k) + begres;
  avgres(k) = avgres(k) + res;
  avgadjust(k) = avgadjust(k) + norm(F(:));
  avgberr(k) = avgberr(k) + berr;
  avgiter(k) = avgiter(k) + iter;
  avgpmag(k) = avgpmag(k) + pmag;
  avgtime(k) = avgtime(k) + t;
  cvg(k) = cvg(k)+1;
disp(i);
end


avgbegres = avgbegres./cvg;
avgadjust = avgadjust./cvg;
avgres = avgres./cvg;
avgberr = avgberr./cvg;
avgiter = avgiter./cvg;
avgpmag = avgpmag./cvg;
avgtime = avgtime./cvg;
